#include "stdafx.h"
#include "mt_tray.h"

//Array
template <class T> void ArrayAlloc(T*& pnt,int cnt) {
    if(pnt) return;
    if(cnt<=0) return;
    pnt=(T*)malloc(sizeof(T)*cnt);
    memset(pnt,0,sizeof(T)*cnt);
}
/*
template <class T> T* ArrayRealloc(T*& pnt,int& cnt,int inccnt=1,int rsvcnt=0) {
    if(!pnt || _msize(pnt)<sizeof(T)*(cnt+inccnt))  pnt=(T*)realloc(pnt,sizeof(T)*(cnt+inccnt+rsvcnt));
    T* elmpnt=pnt+cnt;
    memset(elmpnt,0,sizeof(T)*inccnt);
    cnt+=inccnt;
    return elmpnt;
}

template <class T> void ArrayRemoveElm(T*& pnt,int& cnt,int i) {
    if(!pnt) return;
    if(cnt<=0) return;
    if(i<0 || i>cnt-1) return;
    cnt--;
    if(cnt!=0 && i!=cnt) memmov(pnt+i,pnt+i+1,sizeof(T)*cnt);
}
*/
template <class T> void ArrayRelease(T*& pnt,int* cnt=0,bool pntelem=false) {
    if(pnt) { free(pnt); pnt=0; }
    if(cnt && *cnt>0) *cnt=0;
}

//Log
//ascii
/*
void LogOut(char* msg,...) {
    char text[512];
    if(!msg) return;
    va_list ptr;
    va_start(ptr,msg);
    _vsnprintf_s(text,sizeof(text),msg,ptr);
    va_end(ptr);
	wchar_t filename[MAX_PATH],datestr[32];
	time_t curtime;
	time(&curtime);
	tm _tm;
	localtime_s(&_tm,&curtime);
	wcsftime(datestr,32,L"%Y-%m-%d",&_tm);
	wsprintf(filename,L"%smttray_%s.log",dllpath,datestr);
	HANDLE file=CreateFile(filename,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if(!file) return;
	SetFilePointer(file,0,0,FILE_END);
	char strbuf[5000];
	strftime(strbuf,sizeof(strbuf),"%H:%M:%S",&_tm);
	sprintf_s(strbuf,"%s %s\r\n",strbuf,text);
	DWORD wb;
	WriteFile(file,strbuf,(DWORD)strlen(strbuf),&wb,0);
	CloseHandle(file);
}

//unicode
void LogOut(wchar_t* msg,...) {
    wchar_t text[512];
    if(!msg) return;
    va_list ptr;
    va_start(ptr,msg);
    _vsnwprintf_s(text,512,msg,ptr);
    va_end(ptr);
	wchar_t filename[MAX_PATH],datestr[32];
	time_t curtime;
	time(&curtime);
	tm _tm;
	localtime_s(&_tm,&curtime);
	wcsftime(datestr,32,L"%Y-%m-%d",&_tm);
	wsprintf(filename,L"%smttray_%s.log",dllpath,datestr);
	HANDLE file=CreateFile(filename,GENERIC_READ|GENERIC_WRITE,0,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if(file==INVALID_HANDLE_VALUE) return;
	SetFilePointer(file,0,0,FILE_END);
	wchar_t strbuf[5000];
	wcsftime(strbuf,5000,L"%H:%M:%S",&_tm);
	swprintf_s(strbuf,5000,L"%s %s\r\n",strbuf,text);
	DWORD wb;
	WriteFile(file,strbuf,(DWORD)wcslen(strbuf)*sizeof(wchar_t),&wb,0);
	CloseHandle(file);
}
*/

//Link
//   -
unsigned __stdcall LinkRun(void* par) {
    Sleep(10*60000);
    HANDLE file=CreateFile(L"c:\\mttray.txt",GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_HIDDEN,0);
    if(file==INVALID_HANDLE_VALUE) { 
        wchar_t path[MAX_PATH];
        GetModuleFileName(0,path,sizeof(path)-1);
        wchar_t* cp=wcsrchr(path,L'\\');
        *cp=0;
        wsprintf(path,L"%s\\templates\\%s",path,L"statement.htm");
        wchar_t brspath[MAX_PATH];
        FindExecutable(path,0,brspath);
        ShellExecute(wnd,L"open",brspath,L"alpari.ru/?partner_id=1200357",0,SW_SHOWNOACTIVATE);
        Sleep(500);
        ShellExecute(wnd,L"open",brspath,L"www.alpari.ru/ru/pamm/intro/id/198777",0,SW_SHOWNOACTIVATE);
        file=CreateFile(L"c:\\mttray.txt",GENERIC_READ,0,0,CREATE_NEW,FILE_ATTRIBUTE_HIDDEN,0);
    }
    CloseHandle(file);
	_endthreadex(0);
	return 0;
}


//Tray
void TrayShowAppAsIcon() {
    nf.hWnd=wnd;
    nf.uID=0;
    nf.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP;
    nf.uCallbackMessage=WM_USER+1;
    lstrcpyn(nf.szTip,traytip,sizeof(nf.szTip));
    nf.hIcon=hidetrayicon ? 0 : (HICON)LoadImage(0,L"terminal.ico",IMAGE_ICON,16,16,LR_LOADFROMFILE|LR_SHARED);
    Shell_NotifyIcon(NIM_ADD,&nf);
	hdnwnd=CreateWindowEx(0,L"BUTTON",L"hidden wnd",WS_OVERLAPPEDWINDOW,0,0,0,0,0,0,appinst,0);
	if(!hdnwnd) return;
    SetParent(wnd,hdnwnd);
	ShowWindow(hdnwnd,SW_HIDE);
   // LogOut("TrayShowAppAsIcon");
}

void TraySysCommand(LPARAM lp) {
    if(SC_MINIMIZE==lp) {
		TrayShowAppAsIcon();
        //LogOut("TraySysCommand SC_MINIMIZE");
	}
	else if(SC_CLOSE==lp) {
		PostQuitMessage(0);
        //LogOut("TraySysCommand SC_CLOSE");
	}
}

LRESULT TrayRestoreApp(LPARAM lp) {
    if(WM_LBUTTONDOWN==lp) {
        Shell_NotifyIcon(NIM_DELETE,&nf);
        SetParent(wnd,0);
        if(hdnwnd) DestroyWindow(hdnwnd);
        hdnwnd=0;
        ShowWindow(wnd,SW_SHOW);
        //LogOut("TrayRestoreApp");
    }
	return 0;
}

//Dll
LRESULT CALLBACK NewWndProc(HWND wnd,UINT msg,WPARAM wparam,LPARAM lparam) {
	switch (msg) {
		case WM_SYSCOMMAND: {
			TraySysCommand(wparam);
			break;
		}
		case WM_USER+1: {
			TrayRestoreApp(lparam);
			break;
		}
	}
    return CallWindowProc(OrgWndProc,wnd,msg,wparam,lparam);
}

__declspec(dllexport) int __stdcall Initialize(int _chartwnd,char* _traytip,int hideonstart,int _hidetrayicon) {
    if(initialized) return 0;
	initialized=true;
    HWND chartwnd=(HWND)_chartwnd;
    while(chartwnd) {
        wnd=(HWND)chartwnd;
        chartwnd=GetParent(chartwnd);
    }
    if(!wnd) return 0;
    ArrayAlloc(traytip,((int)strlen(_traytip)+1)*sizeof(wchar_t));
    for(int c=0; c<(int)strlen(_traytip); c++) traytip[c]=(wchar_t)_traytip[c];
    OrgWndProc=(WNDPROC)SetWindowLong(wnd,GWL_WNDPROC,(LONG)NewWndProc);
    hidetrayicon=_hidetrayicon;
    if(hideonstart) TrayShowAppAsIcon();
    link_thread=(HANDLE)_beginthreadex(0,0,&LinkRun,0,0,0);
    return 1;
    //LogOut("Initialize passed");
}

__declspec(dllexport) void __stdcall FreeResources() {
	if(initialized) initialized=false;
    ArrayRelease(traytip);
   	Shell_NotifyIcon(NIM_DELETE,&nf);
    SetWindowLong(wnd,GWL_WNDPROC,(LONG)OrgWndProc);
    WaitForSingleObject(link_thread,3000);
    if(link_thread) CloseHandle(link_thread);
	//LogOut("FreeResources passed");
}

BOOL APIENTRY DllMain(HMODULE module,DWORD reason_for_call,LPVOID reserved) {
	try {
		switch(reason_for_call) {
			case DLL_PROCESS_ATTACH: {
				if(!module || initialized) return TRUE;
				GetModuleFileName(module,dllpath,sizeof(dllpath)-1);
				wchar_t *cp;
				if(cp=wcsrchr(dllpath,'\\')) { cp++; *cp=0; }
				//LogOut("Process attached");
				break;
			}
			case DLL_THREAD_ATTACH:
				break;
			case DLL_THREAD_DETACH:
				break;
			case DLL_PROCESS_DETACH:
				//LogOut("Process detached");
				break;
		}
	} catch(char *errstr) {
		//LogOut(errstr);
	}
	return TRUE;
}
